// LeftScrollbar by Ian Weiner, leftsb@hotmathematician.com 
// See license.txt for licensing info (GPL)

// todo: gmail, on/off toggle, style/frames?

var lsbTabBrowserBox, lsbTabBrowser, lsbTabPanels, lsbTabContainer;
var lsbSB, lsbCurView, lsbInFcn=false;

function lsbInit() 
{
	lsbTabBrowserBox = document.getElementById("appcontent");	
	lsbTabBrowser = document.getElementById("content");
	lsbTabPanels = lsbTabBrowser.mPanelContainer;
	lsbTabContainer = lsbTabBrowser.mTabContainer;
	lsbSB = document.getElementById("leftSB");
	
	lsbSB.addEventListener("DOMAttrModified", lsbSBChangeHandler, false);
	lsbTabBrowserBox.addEventListener("DOMContentLoaded", lsbNewContent, false);
	lsbTabPanels.addEventListener("click", lsbClickHandler, false);
	lsbTabPanels.addEventListener("DOMAttrModified", lsbTabChange, false);
	// handle back/forward in FF1.5+
	try { document.addEventListener("pageshow",lsbUpdateSB,false); } catch(err) { }
}

function lsbDOMChange(e)
{
	lsbUpdateSB();
}

function lsbNewContent(e)
{
	// new page loaded in same tab
	if ((lsbCurView==null)&&(lsbTabBrowser.selectedBrowser.contentDocument==e.target)) {
		lsbCurView=e.target.defaultView;
	}

	//e.target.defaultView.scrollbars.visible=false;
	e.target.documentElement.addEventListener("scroll", lsbScrollHandler, false);
	e.target.documentElement.addEventListener("DOMAttrModified", lsbUpdateSB, false);
	e.target.documentElement.addEventListener("DOMNodeInserted", lsbUpdateSB, false);
	e.target.documentElement.addEventListener("DOMNodeRemoved", lsbUpdateSB, false);
	

	lsbUpdateSB();
}

function lsbUpdateSB()
{
	if (lsbInFcn) return;
	if (lsbCurView==null) return;
	lsbInFcn=true;

	try {
		var docEl = lsbCurView.document.documentElement;
		lsbSB.setAttribute("maxpos", docEl.scrollHeight-lsbCurView.innerHeight); //lsbCurView.scrollMaxY
		lsbSB.setAttribute("pageincrement", lsbCurView.innerHeight);
		lsbSB.setAttribute("curpos", lsbCurView.scrollY);
		lsbSB.setAttribute("collapsed", (lsbCurView.innerHeight < docEl.scrollHeight)?"false":"true");
	} catch(err) { }

	lsbInFcn=false;
}

function lsbScrollHandler(e)
{
	if (lsbCurView != e.target.ownerDocument.defaultView) {
		lsbCurView = e.target.ownerDocument.defaultView;
	}
	lsbUpdateSB();
}

function lsbTabChange(e)
{
	if (e.attrName=="type" && e.newValue=="content-primary") {
		var doc=e.relatedNode.ownerElement.contentDocument;
		lsbCurView=doc.defaultView;
		doc.documentElement.addEventListener("scroll", lsbScrollHandler, false);

		lsbUpdateSB();
	}
}

function lsbClickHandler(e)
{
	var doc=e.target.ownerDocument;
	if (doc != document) {
		if (lsbCurView != e.target.ownerDocument.defaultView) {
			lsbCurView = e.target.ownerDocument.defaultView;
			lsbUpdateSB();
		}
	}
}

function lsbSBChangeHandler(e)
{
	if (lsbInFcn) return;
	if (lsbCurView) {
		lsbInFcn=true;
		try {
			lsbCurView.scrollTo(lsbCurView.scrollX,lsbSB.getAttribute("curpos"));
		} catch(err) {}
		lsbInFcn=false;
	}
}

